SoText3(3)

NAME
SoText3 - The SoText3 class renders extruded 3D text.

SYNOPSIS

#include <Inventor/nodes/SoText3.h>

Inherits SoShape.

  Public Types
enum Part { FRONT = 1, SIDES = 2, BACK = 4, ALL = FRONT|BACK|SIDES }
enum Justification { LEFT = 1, RIGHT, CENTER }

  Public Member Functions
virtual SoType getTypeId (void) const
SbBox3f getCharacterBounds (SoState *state, int stringindex, int charindex)
virtual void GLRender (SoGLRenderAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Public Attributes
SoMFString string
SoSFFloat spacing
SoSFEnum justification
SoSFBitMask parts

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual void generatePrimitives (SoAction *)
virtual void computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
virtual SoDetail * createTriangleDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, const SoPrimitiveVertex *v3, SoPickedPoint *pp)
virtual void notify (SoNotList *list)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoText3 class renders extruded 3D text. Render text as 3D geometry.

The size of the textual geometry representation is decided from the SoFont::size field of a preceding SoFont-node in the scene graph, which specifies the size in unit coordinates. This value sets the approximate vertical size of the letters. The default value if no SoFont-nodes are used, is 10.

This node will create 3D geometry from a specified font defined by a preceding SoFont node. The complexity of the glyphs is controlled by a preceding SoComplexity node with Type set to OBJECT_SPACE. Please note that the default built-in 3D font will not be affected by the SoComplexity node.

This is a simple example of an extruded SoText3 string:

 #Inventor V2.1 ascii
 Separator {
   renderCaching ON
   Font {
      name 'Arial'
      size 2
   }
   ProfileCoordinate2 {
     point [ 0 0,
             0.05 0.05,
             0.25 0.05,
             0.3 0 ]
   }
   LinearProfile {
     index [ 0, 1, 2, 3 ]
   }
   Complexity {
     type OBJECT_SPACE
     value 1
   }
   ShapeHints {
     creaseAngle 1.5
     shapeType SOLID
     vertexOrdering COUNTERCLOCKWISE
   }
   Material {
     diffuseColor 0.6 0.6 0.8
     specularColor 1 1 1
   }
   Text3 {
     string ['Coin3D']
     parts ALL
   }
 }

 Rendering of Example File

if SoText3::Part is set to SIDES or ALL and no profile is provided, a flat, one unit long profile will be created.

Separate colors can be assigned to the front, sides and back of the glyphs by adding a preceding SoMaterialBinding node. Set the value field to PER_PART (default is OVERALL). The front, side and back of the glyphs will then be colored according to diffuse color 0, 1 and 2 found on the stack.

Beware that using a lot of SoText3 text characters in a scene will usually have severe impact on the rendering performance, as each and every character of the text increases the polygon count a lot. This makes SoText3 nodes most suitable in situations where you just need a few characters to be placed in your scene, rather than to visualize complete sentences.

FILE FORMAT/DEFAULTS:

Text3 {
    string ""
    spacing 1
    justification LEFT
    parts FRONT
}

See also
    SoFont, SoFontStyle, SoText2, SoAsciiText, SoProfile

Member Enumeration Documentation

  enum SoText3::Part
Used to specify which parts should be rendered/generated.

Enumerator

FRONT
    Front of characters.

SIDES
    Sides of characters.

BACK
    Back of characters.

ALL All parts.

  enum SoText3::Justification
Used to specify horizontal string alignment.

Enumerator

LEFT
    Left edges of strings are aligned.

RIGHT
    Right edges of strings are aligned.

CENTER
    Centers of strings are aligned.

Member Function Documentation

  SoType SoText3::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoText3::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoShape.

  const SoFieldData ** SoText3::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoText3::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoShape.

  void SoText3::initClass (void) [static]

  SbBox3f SoText3::getCharacterBounds (SoState * state, int stringindex, int charindex)
Not implemented. Should probably have been private in Open Inventor API. Let us know if you need this method for anything, and we'll implement it.

  void SoText3::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShape.

  void SoText3::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoShape.

  void SoText3::generatePrimitives (SoAction * action) [protected], [virtual]
The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

  void SoText3::computeBBox (SoAction * action, SbBox3f & box, SbVec3f & center) [protected], [virtual]
Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

  SoDetail * SoText3::createTriangleDetail (SoRayPickAction * action, const SoPrimitiveVertex * v1, const SoPrimitiveVertex * v2, const SoPrimitiveVertex * v3, SoPickedPoint * pp) [protected], [virtual]
Will create triangle detail for a SoPickedPoint. This method will only be called internally, when generatePrimitives() is used for picking (SoShape::rayPick() is not overridden).

This method returns NULL in Open Inventor, and subclasses will need to override this method to create details for a SoPickedPoint.

This is not necessary with Coin. Of course, if you choose to override it, it will work in the same way as Open Inventor.

For this to work, you must supply a face or line detail when generating primitives. If you supply NULL for the detail argument in SoShape::beginShape(), you'll have to override this method.

Reimplemented from SoShape.

  void SoText3::notify (SoNotList * l) [protected], [virtual]
Notifies all auditors for this instance when changes are made.

Reimplemented from SoShape.

Member Data Documentation

  SoMFString SoText3::string
The set of strings to render. Each string in the multiple value field will be rendered on a separate line.

The default value of the field is a single empty string.

  SoSFFloat SoText3::spacing
Vertical spacing between the baselines of two consecutive horizontal lines. Default value is 1.0, which means that it is equal to the vertical size of the highest character in the bitmap alphabet.

  SoSFEnum SoText3::justification
Determines horizontal alignment of text strings.

If justification is set to SoText3::LEFT, the left edge of the first string is at the origin and all strings are aligned with their left edges. If set to SoText3::RIGHT, the right edge of the first string is at the origin and all strings are aligned with their right edges. Otherwise, if set to SoText3::CENTER, the center of the first string is at the origin and all strings are aligned with their centers. The origin is always located at the baseline of the first line of text.

Default value is SoText3::LEFT.

  SoSFBitMask SoText3::parts
Character parts. Default is to show only the front facing part.

Author

Generated automatically by Doxygen for Coin from the source code.